package model

import "esway/internal/sqlType"

type Token struct {
	Id        uint64 `json:"id" gorm:"primaryKey;column:id"`
	CreatedAt int64  `json:"created_at" gorm:"column:created_at;autoCreateTime:milli"`
	UpdatedAt int64  `json:"updated_at" gorm:"column:updated_at;autoUpdateTime:milli"`
	DeletedAt int64  `json:"deleted_at" gorm:"index;column:deleted_at;default:0"`

	CreatedBy uint64
	Token     string
	Comment   string
}

type TokenIndex struct {
	Id        uint64 `json:"id" gorm:"primaryKey;column:id"`
	CreatedAt int64  `json:"created_at" gorm:"column:created_at;autoCreateTime:milli"`
	UpdatedAt int64  `json:"updated_at" gorm:"column:updated_at;autoUpdateTime:milli"`
	DeletedAt int64  `json:"deleted_at" gorm:"index;column:deleted_at;default:0"`

	TokenId uint64
	Index   string
	APIs    sqlType.StrSlice
}

type ESApi string

const (
	ESApiUnknown       ESApi = "unknown"
	ESApiSearch        ESApi = "search"
	ESApiGetDoc        ESApi = "doc"
	ESApiUpdateDoc     ESApi = "update"
	ESApiUpdateByQuery ESApi = "update_by_query"
	ESApiReindex       ESApi = "reindex"
)
